//KeineFormate_502d.js
// 16.05.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Verknpfungen mit Formaten aufheben

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// eine Referenz zum vordersten Dokument
curDoc = app.documents[0];

// die Sperrung der Ebenen speichern und aufheben (falls notwendig)
var allLayers = curDoc.layers;
var nLayers = allLayers.length;
var layerLocks = new Array ();
for (var i=0; i<nLayers; i++) {
	if (allLayers[i].locked == true) {
		allLayers[i].locked = false;
		layerLocks.push(true);
	}
	else {
		layerLocks.push(false);
	}
}

// die Sperrung der Rahmen aufheben
curDoc.pageItems.everyItem().locked = false;

// Absatz- und Zeichenformat "Kein"
try {
	var noParaStyle = curDoc.paragraphStyles[0];
	var noCharStyle = curDoc.characterStyles[0];
}
catch (e) {
}

// die Absatzformate
var allParaStyles = curDoc.allParagraphStyles;
var nParaStyles = allParaStyles.length;

// die Grep-Vorgaben zurcksetzen
app.findGrepPreferences = app.changeGrepPreferences = null;
// Musterseiten bercksichtigen
app.findChangeGrepOptions.includeMasterPages = true;

// Auswahl prfen ...
var curSel = app.selection;
var nSel   = curSel.length;

// das Zielobjekt
if (nSel == 0) {
	var curObj = curDoc;
	// die Textketten auflisten und zhlen
	allStories = curObj.stories;
	nStories   = allStories.length;
	convNums(curObj);
	setStyles(curObj);
	remStyles(curObj);
}
else {
	for (var i=0; i<nSel; i++) {
		if (curSel[i].constructor.name != "Group") {
			try {
				curObj = curSel[i].paragraphs.everyItem();
				convNums(curObj);
				setStyles(curObj);
				remStyles(curObj);
			}
			catch (e) {
			}
		}
		else {
			var allObj = curSel[i].allPageItems;
			var nObj   = allObj.length;
			for (var k=0; k<nObj; k++) {
				try {
					curObj = allObj[k].paragraphs.everyItem();
					convNums(curObj);
					setStyles(curObj);
					remStyles(curObj);
				}
				catch (e) {
				}
			}
		}
	}
}

// Nummerierungen und Aufzhlungen in Text konvertieren
function convNums(curObj) {
	if (curObj == curDoc) {
		for (var s=0; s<nStories; s++) {
			try {
				allStories[s].paragraphs.everyItem().convertBulletsAndNumberingToText();
			}
			catch (e) {
			}
			// die Tabellen auch behandeln
			try {
				allStories[s].tables.everyItem().cells.everyItem().texts[0].convertBulletsAndNumberingToText();
			}
			catch (e) {
			}
		}
	}
	else {
		try {
			curObj.convertBulletsAndNumberingToText();
		}
		catch (e) {
		}
		// die Tabellen auch behandeln
		try {
			curObj.tables.everyItem().cells.everyItem().texts[0].convertBulletsAndNumberingToText();
		}
		catch (e) {
		}
	}
}

// den GREP-Stilen die Zeichenformate zuweisen
function setStyles(curObj) {
	// eine Schleife durch die Absatzformate
	for (p=0; p<nParaStyles; p++) {
		var allGrepStyles = allParaStyles[p].nestedGrepStyles;
		var nGrepStyles   = allGrepStyles.length;
		for (n=0; n<nGrepStyles; n++) {
			var curGrep = allGrepStyles[n].grepExpression;
			var curParaStyle  = allParaStyles[p];
			var curCharStyle  = allGrepStyles[n].appliedCharacterStyle;
			var curGrepChange = NothingEnum.nothing;
			app.findGrepPreferences.appliedParagraphStyle = curParaStyle;
			app.findGrepPreferences.appliedCharacterStyle = null;
			app.changeGrepPreferences.appliedCharacterStyle = curCharStyle;
			app.findGrepPreferences.findWhat = curGrep;
			app.changeGrepPreferences.changeTo = "";
			try {
				curObj.changeGrep();
			}
			catch (e) {
			}
		}
	}
}

// die beiden "Kein Format" zuweisen
function remStyles(curObj) {
	if (curObj == curDoc) {
		// eine Schleife durch jede Story und die beiden "Kein Format" zuweisen
		for (var s=0; s<nStories; s++) {
			try {
				allStories[s].paragraphs.everyItem().applyCharacterStyle(noCharStyle);
			}
			catch (e) {
			}
			try {
				allStories[s].paragraphs.everyItem().applyParagraphStyle(noParaStyle, false);
			}
			catch (e) {
			}
			// die Tabellen auch behandeln
			try {
				allStories[s].tables.everyItem().cells.everyItem().texts[0].applyCharacterStyle(noCharStyle);
			}
			catch (e) {
			}
			try {
				allStories[s].tables.everyItem().cells.everyItem().texts[0].applyParagraphStyle(noParaStyle, false);
			}
			catch (e) {
			}
		}
	}
	else {
		try {
			curObj.paragraphs.everyItem().applyCharacterStyle(noCharStyle);
		}
		catch (e) {
		}
		try {
			curObj.paragraphs.everyItem().applyParagraphStyle(noParaStyle, false);
		}
		catch (e) {
		}
		// die Tabellen auch behandeln
		try {
			curObj.tables.everyItem().cells.everyItem().texts[0].applyCharacterStyle(noCharStyle);
		}
		catch (e) {
		}
		try {
			curObj.tables.everyItem().cells.everyItem().texts[0].applyParagraphStyle(noParaStyle, false);
		}
		catch (e) {
		}
	}
}

// die Grep-Vorgaben zurcksetzen
app.findGrepPreferences = app.changeGrepPreferences = null;

// die Sperrung der Ebenen wiederherstellen (falls notwendig)
for (var i=0; i<(nLayers); i++) {
	allLayers[i].locked = layerLocks[i];
}

// den Anwender informieren
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
$.sleep(999);
dlog.close();